<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>

<body>

</body>

</html>
<script>
    function foo() {
        if (true) {
            var fruit1 = 'apple';
            const fruit2 = 'banana';
            let fruit3 = 'strawberry';
        }
        console.log(fruit1);
        console.log(fruit2);
        console.log(fruit3);
    }
    foo();
    //out put
    // apple
    // ReferenceError: fruit2 is not defined
    // ReferenceError: fruit3 is not defined
    //Biến fruit1 được khai báo bằng var nên nó có phạm vi (scope) là hàm foo(). Do đó, biến fruit1 có thể truy cập được trong toàn bộ hàm foo(), bao gồm cả sau khối if. Vì vậy, khi gọi console.log(fruit1), giá trị 'apple' được in ra.
    //Biến fruit2 được khai báo bằng const nên nó chỉ có phạm vi trong khối { } của if.Nếu ta gọi console.log(fruit2) sau khối if, nó sẽ không tìm thấy biến fruit2 và gây ra lỗi "ReferenceError: fruit2 is not defined".Vì const có phạm vi chỉ trong khối, biến fruit2 không thể truy cập từ bên ngoài khối if.
    //Tương tự, biến fruit3 được khai báo bằng let nên nó chỉ có phạm vi trong khối { } của if.Nếu ta gọi console.log(fruit3) sau khối if, nó sẽ không tìm thấy biến fruit3 và cũng gây ra lỗi "ReferenceError: fruit3 is not defined".Vì let cũng có phạm vi chỉ trong khối, biến fruit3 không thể truy cập từ bên ngoài khối if.



    function foo1() {
        var fruit1 = 'apple';
        const fruit2 = 'banana';
        let fruit3 = 'strawberry'; function foo2() {
            console.log(fruit1);
            console.log(fruit2);
            console.log(fruit3);
        }
        foo2();
    }
    foo1();
    //Vì biến fruit1 là biến toàn cục được khai báo bằng var, 
    //nên nó có thể truy cập được từ bên trong hàm con foo2. 
    //Biến fruit2 và fruit3 được khai báo trong hàm foo1 sử dụng const và let có phạm vi chỉ trong hàm foo1, 
    //nhưng vẫn có thể truy cập từ bên trong hàm con foo2 bởi vì hàm con được tạo bên trong phạm vi của hàm cha. 
    //Do đó, khi gọi foo2(), các biến fruit1, fruit2, và fruit3 đều có thể truy cập được và in ra giá trị tương ứng.
</script>